////////////////////////////////////////////////////////////////////////
////                          OS_Chrono.c                           ////
////                                                                ////
////  Programme principal du chrono									////
////                 18F242 quartz 4Mhz					 			////
////  Auteur: 	LG					     							////
////  Date:	 06 janvier 2005 										////
////                                                                ////
////////////////////////////////////////////////////////////////////////
////        (C) Copyright 2005 - LG				             		////
////								     							////
////////////////////////////////////////////////////////////////////////
// version 1.0 Gestion de la seconde.




// code final
//#include "OS_Chrono.h"
#include <delays.h>
#include <timers.h>
#include <pwm.h>
#include <adc.h>
#include <usart.h>
#include <p18f242.h>  // processeur PIC 18F242
#include <spi.h>
#include <string.h>

#define uchar unsigned char
#define uint unsigned int

#pragma romdata CONFIG
_CONFIG_DECL (
_CONFIG1H_DEFAULT & _OSC_HS_1H ,		// Mode Horloge			
_CONFIG2L_DEFAULT & _PWRT_ON_2L ,
_CONFIG2H_DEFAULT & _WDT_OFF_2H,		// pas de watchdog
_CONFIG3H_DEFAULT,
_CONFIG4L_DEFAULT & _STVR_ON_4L & _LVP_OFF_4L & _DEBUG_OFF_4L , //Stack overflow reset, debug off, LVP ICSP prog off
_CONFIG5L_DEFAULT & _CP0_OFF_5L & _CP1_OFF_5L, // pas de protection de code
_CONFIG5H_DEFAULT & _CPB_OFF_5H & _CPD_OFF_5H, 		// pas de protection EEPROM et boot code
_CONFIG6L_DEFAULT & _WRT0_OFF_6L & _WRT1_OFF_6L, //
_CONFIG6H_DEFAULT & _WPC_OFF_6H & _WPB_OFF_6H & _WPD_OFF_6H,
_CONFIG7L_DEFAULT & _EBTR0_OFF_7L & _EBTR1_OFF_7L,
_CONFIG7H_DEFAULT & _EBTRB_OFF_7H
);
#pragma romdata

#define TEMPS_CHRONO_REFERENCE 90	// soit 1min30
#define AFFICHE_P			0xB0		// valeur pour avoir un P  l'cran.
#define AFFICHE_OK			0x82	// valeur pour le OK	O..
#define ETEINDRE			0xFF	// on est en logique inverse.
#define BARRE				0xBF	// on affiche une barre en bas de l'afficheur
// dfinition des bouton
#define BOUTON_START		PORTBbits.RB0			// Bouton pour lancer le chrono.
#define BOUTON_INC			PORTBbits.RB1			// Bouton d'incrmentation 
#define PORT_AFFICHAGE_A 	LATA			// pour afficher un digit.
#define POINT_DIGIT			PORTCbits.RC1	// pour afficher un point sur un digit
#define PORT_AFFICHAGE_C	PORTCbits.RC0 	// Poids fort du nombre.

#define SELECTION_CENTAINE 		0x10 		// Les donnes en entre des latch sont transmissent au sortie
#define DESELECTION_CENTAINE 	0 	// Les donnes de sortie restent identiques
#define SELECTION_DIZAINE		0x08
#define DESELECTION_DIZAINE		0
#define SELECTION_UNITE 		0x04
#define DESELECTION_UNITE 		0


// dclaration des fonctions
void OS_AffichageCaractere(uchar PUC_VariableCaractere);
void OS_AffichageTemps(uint PUI_VariableTemps);
void OS_ConfigurationProcesseur(void);
void OS_EffacementAffichage(void);

void Afficher0(uchar PUC_Digit);
void Afficher1(uchar PUC_Digit);
void Afficher2(uchar PUC_Digit);
void Afficher3(uchar PUC_Digit);
void Afficher4(uchar PUC_Digit);
void Afficher5(uchar PUC_Digit);
void Afficher6(uchar PUC_Digit);
void Afficher7(uchar PUC_Digit);
void Afficher8(uchar PUC_Digit);
void Afficher9(uchar PUC_Digit);
void EffacementCentaine(void);
void EffacementDizaine(void);
void EffacementUnite(void);
void AffichageLG(void);
/********************************************************
Fonction: main
Utilisation: Fonction principal du programme appel au boot du PIC
Date: 20/02/2005
Auteur: LG
********************************************************/

void main (void)
{
// dclaration de variables locales
// dbut du corps de la fonction

	uint LUI_Compteur;							// variable utilis pour le dcomptage.
	uint LUI_TempsReference;					// variable qui stocke le temps de rfrence  utiliser
//----------------------------
// configuration du processeur
//----------------------------
	OS_ConfigurationProcesseur();
	AffichageLG();
	Delay10KTCYx(200);						// attente de 2s
	// effacement des l'affichage.
	OS_EffacementAffichage();

	// affiche des nombres pour les units.
//	 PORTC =0x00;

/*											// test pour savoir quel temps de rfrence on utilise.
	if(BOUTON_START ==0)
	{	// on veut mettre sa propre valeur
		LUI_TempsReference =0;
		OS_AffichageCaractere(AFFICHE_P);		// pour programmation
		Delay10KTCYx(200);						// attente de 2s
		OS_AffichageTemps(LUI_TempsReference);
		while (BOUTON_START ==1)				// on boucle tant qu'on n'a pas appuy sur start, c'est l'tat par dfaut.
		{	
			if( BOUTON_INC ==0)					// on appuy sur l'incrementation
			{
				if (LUI_TempsReference < 999)	// on ne peut pas dpaser 999 secondes
					LUI_TempsReference++;
				OS_AffichageTemps(LUI_TempsReference);
				Delay10KTCYx(50);					// attente de 0.5s
			}
		}
		Delay10KTCYx(200);						// attente de 2s
		OS_AffichageCaractere(AFFICHE_OK);
		Delay10KTCYx(200);						// attente de 2s
	}
	else
	{											// on utilise la valeur par dfaut.
		LUI_TempsReference=	TEMPS_CHRONO_REFERENCE;
	}
*/
	LUI_TempsReference=	TEMPS_CHRONO_REFERENCE;
	while (1)									// boucle principale du programme de gestion du compteur.
	{
		// rcupration du temps.
		LUI_Compteur = LUI_TempsReference;
		OS_AffichageTemps(LUI_Compteur);		// affichage du temps
		while(BOUTON_START == 1 );				// on boucle en attendant qu'on appuye sur le bouton actif niveau bas.
		while (LUI_Compteur >0)
		{
			Delay10KTCYx(99);					// attente de 1s	ajustement du temps de boucle.
			Delay1KTCYx(9);						// attente de 1s	ajustement du temps de boucle.
			Delay100TCYx(2);						// attente de 1s	ajustement du temps de boucle.
			Delay10TCYx(2);
			Delay1TCY();
			Delay1TCY();
			Delay1TCY();
			Delay1TCY();
			LUI_Compteur= LUI_Compteur-1;						// on dcremente.
			OS_AffichageTemps(LUI_Compteur);	// affichage du temps
			if (BOUTON_START == 0)				// utile si on veut arreter le comptage.
			{
				LUI_Compteur =0;				// on sort!
				OS_AffichageTemps(0);			// on reset l'affichage  0
			}
		}
		OS_EffacementAffichage();
		Delay10KTCYx(200);					// attente de 2s	ajustement du temps de boucle.
//		while(BOUTON_START == 1 );				// on boucle en attendant qu'on appuye sur le bouton. Pour remettre en route.
	}
}

/********************************************************
Fonction: OS_EffacementAffichage
Utilisation: Fonction effacement de l'affichage
Date: 20/02/2005
Auteur: LG
********************************************************/
void OS_EffacementAffichage(void)
{
LATA =0x00;
LATC =0x00;
PORTA=0x00;
PORTC=0x04;	// slection des units.
PORTC = 0x08; // slection des dizaines
PORTC = 0x10;	// slection des centaines
PORTC=0;
}

/********************************************************
Fonction: OS_AffichageTemps
Utilisation: Fonction d'affichage d'un caractre.
Date: 20/02/2005
Auteur: LG
********************************************************/
/*
void OS_AffichageCaractere(uchar PUC_VariableCaractere)
{
	// dclaration de variable locale

	//dbut du corps de la fonction

	switch(PUC_VariableCaractere)	
	{
	case AFFICHE_P:

			OS_EcrirePortData( AFFICHE_P);
			
			SELECTION_CENTAINE;			// positionne le CS centaine  1
			DESELECTION_CENTAINE;		// positionne le CS centaine  1
			OS_EcrirePortData( ETEINDRE);	
			SELECTION_DIZAINE;			// positionne le CS dizaine  1
			DESELECTION_DIZAINE;		// positionne le CS dizaine  1
			OS_EcrirePortData( ETEINDRE);
			SELECTION_UNITE;			// positionne le CS unite  1
			DESELECTION_UNITE;			// positionne le CS unite  1
			break;
	case AFFICHE_OK:
				
			OS_EcrirePortData( AFFICHE_OK	);	// pour avoir un 0
			SELECTION_CENTAINE;			// positionne le CS centaine  1
			DESELECTION_CENTAINE;		// positionne le CS centaine  1
			OS_EcrirePortData( BARRE);		// pour avoir une barre en dessous
			SELECTION_DIZAINE;			// positionne le CS dizaine  1
			DESELECTION_DIZAINE;		// positionne le CS dizaine  1
			OS_EcrirePortData( BARRE);		// pour avoir une barre en dessous
			SELECTION_UNITE;			// positionne le CS unite  1
			DESELECTION_UNITE;			// positionne le CS unite  1
			break;
	default:							// autre cas  dfinir
			break;



	}
}
*:
/********************************************************
Fonction: OS_AffichageTemps
Utilisation: Fonction d'affichage du temps.
Date: 20/02/2005
Auteur: LG
********************************************************/
void OS_AffichageTemps(uint PUI_VariableTemps)
{
	//dclaration de variable locale
	uint LUI_temp;
	uchar LUC_Flag=0;
	OS_EffacementAffichage();	// on commence toujours par effacer.

	// dbut du corps de la fonction
	// affichage des centaines de secondes.
	LUI_temp = PUI_VariableTemps /100;
	if ( LUI_temp ==0)
	{
		LUC_Flag =1;	// on positionne le flag
		EffacementCentaine();	
	}
	else
	{
		switch (LUI_temp)
		{
			case 0:
					Afficher0(SELECTION_CENTAINE );
					break;
			case 1:
					Afficher1(SELECTION_CENTAINE );
					break;
			case 2:
					Afficher2(SELECTION_CENTAINE );
					break;
			case 3:
					Afficher3(SELECTION_CENTAINE );
					break;
	
			case 4:
					Afficher4(SELECTION_CENTAINE );
					break;
	
			case 5:
					Afficher5(SELECTION_CENTAINE );
					break;
	
			case 6:
					Afficher6(SELECTION_CENTAINE );
					break;
			case 7:
					Afficher7(SELECTION_CENTAINE );	
					break;
			case 8:
					Afficher8(SELECTION_CENTAINE );
					break;
			case 9:
					Afficher9(SELECTION_CENTAINE );
					break;
			default:
					break;
		}
	}
	PUI_VariableTemps = PUI_VariableTemps - LUI_temp*100;
	// affichage des dizaines
	LUI_temp = PUI_VariableTemps /10;
	if ((LUI_temp ==0)&& (LUC_Flag ==1))
	{
		LUC_Flag =1;
		EffacementDizaine();
	}
	else
	{
		LUC_Flag=0;
		switch (LUI_temp)
		{
			case 0:
					Afficher0(SELECTION_DIZAINE );
					break;
			case 1:
					Afficher1(SELECTION_DIZAINE );
					break;
			case 2:
					Afficher2(SELECTION_DIZAINE );
					break;
			case 3:
					Afficher3(SELECTION_DIZAINE );
					break;
	
			case 4:
					Afficher4(SELECTION_DIZAINE );
					break;
	
			case 5:
					Afficher5(SELECTION_DIZAINE );
					break;
	
			case 6:
					Afficher6(SELECTION_DIZAINE );
					break;
			case 7:
					Afficher7(SELECTION_DIZAINE );	
					break;
			case 8:
					Afficher8(SELECTION_DIZAINE );
					break;
			case 9:
					Afficher9(SELECTION_DIZAINE );
					break;
			default:
					break;
		}
	}
	PUI_VariableTemps = PUI_VariableTemps - LUI_temp*10;
	LUI_temp = PUI_VariableTemps;
	// affichage des units.
	switch (LUI_temp)
	{
		case 0:
				Afficher0(SELECTION_UNITE );
				break;
		case 1:
				Afficher1(SELECTION_UNITE );
				break;
		case 2:
				Afficher2(SELECTION_UNITE );
				break;
		case 3:
				Afficher3(SELECTION_UNITE );
				break;

		case 4:
				Afficher4(SELECTION_UNITE );
				break;

		case 5:
				Afficher5(SELECTION_UNITE );
				break;

		case 6:
				Afficher6(SELECTION_UNITE );
				break;
		case 7:
				Afficher7(SELECTION_UNITE );	
				break;
		case 8:
				Afficher8(SELECTION_UNITE );
				break;
		case 9:
				Afficher9(SELECTION_UNITE );
				break;
		default:
				break;
	}

}



/********************************************************
Fonction: OS_ConfigurationProcesseur(void)
Utilisation: Fonction pour la configuration du processeur
Date: 25/05/2004
Auteur: LG
********************************************************/
void OS_ConfigurationProcesseur(void)
{
// dclarations de variables locales

// dbut du corps de la fonction
//Configuration du port A
	TRISA = 0x00; // port A RA0 -RA5 en sortie
// Configuration du port B
	TRISB = 0xFF;	// port B : en entre
// Configuration du port C
	TRISC = 0x00; // RC0-RC4 en sortie, RC5-RC7 en entre ...  reconfigurer avec le RS485.

}
/********************************************************
Fonction: OS_Afficher0
Utilisation: Fonction pour affichage du 0
Date: 25/04/2005
Auteur: LG
********************************************************/
void Afficher0(uchar PUC_Digit)
{
LATC=0;
LATA =0;
PORTC = 0x01|PUC_Digit;
PORTA = 0x3D;
PORTC = 0x01|PUC_Digit;
PORTC = 0x00;
}
/********************************************************
Fonction: OS_Afficher1
Utilisation: Fonction pour affichage du 1
Date: 25/04/2005
Auteur: LG
********************************************************/
void Afficher1(uchar PUC_Digit)
{
LATC=0;				
LATA =0;
PORTC = 0x01|PUC_Digit;
PORTA = 0x20;
PORTC = 0x01|PUC_Digit;	
PORTC = 0x00;
}
/********************************************************
Fonction: OS_Afficher2
Utilisation: Fonction pour affichage du 2
Date: 25/04/2005
Auteur: LG
********************************************************/
void Afficher2(uchar PUC_Digit)
{
LATC=0;
LATA =0;
PORTC = 0x01|PUC_Digit;
PORTA = 0x1B;
PORTC = 0x01|PUC_Digit;	
PORTC = 0x00;
}
/********************************************************
Fonction: OS_Afficher3
Utilisation: Fonction pour affichage du 3
Date: 25/04/2005
Auteur: LG
********************************************************/
void Afficher3(uchar PUC_Digit)
{
LATC=0;
LATA =0;
PORTC = 0x01|PUC_Digit;
PORTA = 0x33;
PORTC = 0x01|PUC_Digit;	
PORTC = 0x00;
}
/********************************************************
Fonction: OS_Afficher4
Utilisation: Fonction pour affichage du 4
Date: 25/04/2005
Auteur: LG
********************************************************/
void Afficher4(uchar PUC_Digit)
{
LATC=0;
LATA =0;
PORTC = 0x00|PUC_Digit;
PORTA = 0x26;
PORTC = 0x00|PUC_Digit;	
PORTC = 0x00;
}
/********************************************************
Fonction: OS_Afficher5
Utilisation: Fonction pour affichage du 5
Date: 25/04/2005
Auteur: LG
********************************************************/
void Afficher5(uchar PUC_Digit)
{
LATC=0;
LATA =0;
PORTC = 0x00|PUC_Digit;
PORTA = 0x37;
PORTC = 0x00|PUC_Digit;	
PORTC = 0x00;
}
/********************************************************
Fonction: OS_Afficher6
Utilisation: Fonction pour affichage du 6
Date: 25/04/2005
Auteur: LG
********************************************************/
void Afficher6(uchar PUC_Digit)
{
LATC=0;
LATA =0;
PORTC = 0x00|PUC_Digit;
PORTA = 0x3E;
PORTC = 0x00|PUC_Digit;	
PORTC = 0x00;
}
/********************************************************
Fonction: OS_Afficher7
Utilisation: Fonction pour affichage du 7
Date: 25/04/2005
Auteur: LG
********************************************************/
void Afficher7(uchar PUC_Digit)
{
LATC=0;
LATA =0;
PORTC = 0x01|PUC_Digit;
PORTA = 0x21;
PORTC = 0x01|PUC_Digit;	
PORTC = 0x00;
}
/********************************************************
Fonction: OS_Afficher8
Utilisation: Fonction pour affichage du 8
Date: 25/04/2005
Auteur: LG
********************************************************/
void Afficher8(uchar PUC_Digit)
{
LATC=0;
LATA =0;
PORTC = 0x01|PUC_Digit;
PORTA = 0x3F;
PORTC = 0x01|PUC_Digit;
PORTC = 0x00;
}
/********************************************************
Fonction: OS_Afficher9
Utilisation: Fonction pour affichage du 9
Date: 25/04/2005
Auteur: LG
********************************************************/
void Afficher9(uchar PUC_Digit)
{
LATC=0;
LATA =0;
PORTC = 0x01|PUC_Digit;
PORTA = 0x37;
PORTC = 0x01|PUC_Digit;	
PORTC = 0x00;
}
/********************************************************
Fonction: OS_EffacementCentaine
Utilisation: Fonction pour l'effacement du digit des centaines
Date: 25/04/2005
Auteur: LG
********************************************************/
void EffacementCentaine(void)
{
	// fonction pour l'effacement du digits des centaines.
	LATA=0x00;
	LATC=0x00;
	PORTC=0x10;
	PORTA=0x00;
	PORTC=0x10;
	PORTC=0x00;
}
/********************************************************
Fonction: OS_EffacementDizaine
Utilisation: Fonction pour l'effacement du digit des centaines
Date: 25/04/2005
Auteur: LG
********************************************************/
void EffacementDizaine(void)
{
	// fonction pour l'effacement du digits des dizaines
	LATA=0x00;
	LATC=0x00;
	PORTC=0x08;
	PORTA=0x00;
	PORTC=0x08;
	PORTC=0x00;
}
/********************************************************
Fonction: OS_EffacementUnit
Utilisation: Fonction pour l'effacement du digit des centaines
Date: 25/04/2005
Auteur: LG
********************************************************/
void EffacementUnite(void)
{
	// fonction pour l'effacement du digits des units
	LATA=0x00;
	LATC=0x00;
	PORTC=0x04;
	PORTA=0x00;
	PORTC=0x04;
	PORTC=0x00;
}
/********************************************************
Fonction: OS_AffichageLG
Utilisation: Fonction pour l'affichage de LG (a c'est mes initiales!!!)
Date: 25/04/2005
Auteur: LG
********************************************************/
void AffichageLG(void)
{
	// gestion du digit des centaines. L
	LATA=0x00;
	LATC=0x00;
	PORTC=0x10;
	PORTA=0x1C;
	PORTC=0x10;
	PORTC=0x00;
	// Gestion du digit des dizaine. G
	LATA=0x00;
	LATC=0x00;
	PORTC=0x08;
	PORTA=0x3F;
	PORTC=0x08;
	PORTC=0x00;
	// Gestion du digit des unit _
	LATA=0x00;
	LATC=0x00;
	PORTC=0x04;
	PORTA=0x10;
	PORTC=0x04;
	PORTC=0x00;
	// delai.
	Delay10KTCYx(200);		// attente de 2s
}
// fin du fichier